import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Ship here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ship  extends SmoothMover
{
    public static int lives = 5;
    private double speed = 5;
    private int i = 0;
    private final int BULLET_MAX = 15;
    private int bulletCount;
    private boolean win;
    private boolean canMove = true;
    private boolean playSound;
    private boolean canDie;
    private int dieCounter;
    private final int dieMax = 150;
    

    public Ship(boolean canDie)
    {
        dieCounter = 0;
        this.canDie = canDie;
        win = false;
        playSound = true;
        bulletCount = BULLET_MAX;
        increaseSpeed(new Vector(getRotation(), 0));
    }

    /**
     * Act - do whatever the Ship wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(!canDie)
        {
            dieCounter++;
        }
        
        countBullets();
        if(canMove){
        checkKeys();}
        checkBounds();
        checkWin();
        checkMars();
        winMove();
        checkEnemy();
        invincibility();
    }  
    
    public void invincibility()
    {
        if(dieCounter%2 == 0)
        {
            GreenfootImage image = getImage();
            image.setTransparency(255);
            setImage(image);
        }
        else
        {
            GreenfootImage image = getImage();
            image.setTransparency(0);
            setImage(image);
        }
        if(dieCounter == dieMax)
        {
            getWorld().addObject(new Ship(true), getX(), getY());
            getWorld().removeObject(this);
        }
    }
    
    public void checkMars()
    {
        Actor m = getOneIntersectingObject(Mars.class);
        if(m != null)
        {
            if(playSound)
                {
                    playSound = false;
                    Greenfoot.playSound("toilet.wav");
                }
        }
    }
    
    public void winMove()
    {
        if(win)
        {
            if(getX() < 650)
            {
                setLocation(getX()+2, getY());
            }
            if(getY() < 150)
            {
                setLocation(getX(), getY()+2);
            }
            if(getY() > 250)
            {
                setLocation(getX(), getY()-2);
            }
        }
    }
    
    public void checkWin()
    {
        List enemies = getWorld().getObjects(Enemy.class);
        if(enemies.size() == 0 && win == false)
        {
            win = true;
            canMove = false;
            getWorld().addObject(new Mars(), 1000, 200);
            getWorld().addObject(new Board("You defeated the Martians!"), getWorld().getWidth()/2, getWorld().getHeight()/2);
        }
    }
    
    public void countBullets()
    {
        if(bulletCount == BULLET_MAX)
        {
            bulletCount = 0;
        }
        else
        {
            bulletCount++;
        }
    }
    
    public void checkEnemy()
    {
        Actor enemy = getOneIntersectingObject(Enemy.class);
        if(enemy != null && canDie)
        {
            MyWorld.score = MyWorld.score-100;
                lives--;
                MyWorld.shipX = getX();
                MyWorld.shipY = getY();
                getWorld().addObject(new Explosion(), getX(), getY());
                getWorld().removeObject(this);
        }
    }
    
    public void checkBounds()
    {
        if(getY() <= 5)
        {
            canMove = false;
            move(0, 1);
        }
        if(getY() > 5 && !win)
        {
            canMove = true;
        }
    }
    
    public void checkKeys()
    {
        if(Greenfoot.isKeyDown("up") && !Greenfoot.isKeyDown("down") && canMove)
        {
            move(0, -5);
        }
        if(Greenfoot.isKeyDown("down") && !Greenfoot.isKeyDown("up") && canMove)
        {
            move(0, 5);
        }
        if(Greenfoot.isKeyDown("space"))
        {
            if(bulletCount == BULLET_MAX){
                Greenfoot.playSound("shoot.wav");
                getWorld().addObject(new Bullet(), getX()+getImage().getWidth()/2, getY()-1);
            }
        }
    }
    
    public void move(double x, double y)
    {
        setLocation(getX()+x, getY()+y);
    }
}
